<?php
/**
 (c) DHTMLX Ltd, 2011
 Licensing: You allowed to use this component for free under GPL or you need to obtain Commercial/Enterprise license to use it in non-GPL project
 Contact: sales@dhtmlx.com
 **/

require_once('spreadsheet_common.php');

function get_sh_obj() {
	$sh_cfg = new SpreadsheetCfg();
	$sh_cfg->set('prefix', $modx->db->config['table_prefix']);
	$sh_cfg->set('plugin', MODX_BASE_URL.'core/components/spreadsheet/');
	$sh_cfg->set('connector', MODX_BASE_URL.'core/components/spreadsheet/spreadsheet_data.php');
	return $sh_cfg;
}

function sh_check($modx, $id, $width, $height, $autowidth, $autoheight, $skin, $math, $color_scheme) {
	$ver = phpversion();
	$ver_main = (int) substr($ver, 0, 1);
	if ( $ver_main < 5)
		return __('Installation error: Spreadsheet plugin requires PHP 5.x', 'spreadsheet');

	sh_load_dump($modx);

	$sh_cfg = get_sh_obj();
	$options = Array();
	if ($id !== null) $options['id'] = $id;
	if ($width !== null) $options['width'] = $width;
	if ($height !== null) $options['height'] = $height;
	if ($autowidth !== null) $options['autowidth'] = $autowidth;
	if ($autoheight !== null) $options['autoheight'] = $autoheight;
	if ($skin !== null) $options['skin'] = $skin;
	if ($math !== null) $options['math'] = $math;
	if ($color_scheme !== null) $options['color_scheme'] = $color_scheme;

	foreach ($options as $name => $value) {
		$sh_cfg->set($name, $value);
	}
	if (!isset($options['height']))
		$sh_cfg->set('autoheight', 'true');
	
	$text = $sh_cfg->get_spreadsheet_client();
	return $text;
}


function sh_load_dump($modx, $drop = false) {
	require(dirname(__FILE__)."/../../config/config.inc.php");
	$conn = mysql_connect($database_server, $database_user, $database_password);
	mysql_select_db($dbase, $conn);

	$res = @mysql_query("SELECT * FROM {$table_prefix}dhx_data", $conn);
	if ($res === false || mysql_errno($conn) != 0) {
		$query = "SELECT * FROM {$table_prefix}data";
		$res = mysql_query($query, $conn);
		if ($res === false || mysql_errno($conn) != 0) {
			$queries = get_sh_obj()->get('queries');
			for ($i = 0; $i < count($queries); $i++) {
				$query = str_replace('#__', $table_prefix, $queries[$i]);
				mysql_query($query, $conn);
			}
		} else {
			// rename tables
			$tables_list = array("data", "header", "sheet", "triggers", "user");
			for ($i = 0; $i < count($tables_list); $i++) {
				mysql_query("ALTER TABLE {$table_prefix}{$tables_list[$i]} RENAME TO {$table_prefix}dhx_{$tables_list[$i]}", $conn);
			}
		}

	}
	$query = "SELECT sheetid FROM {$table_prefix}dhx_triggers LIMIT 1";
	$res = mysql_query($query, $conn);
	if ($res === false || mysql_errno($conn) != 0) {
		// migrate call
		require_once(dirname(__FILE__).'/codebase/php/migrate.php');
		require_once(dirname(__FILE__).'/codebase/php/db_common.php');
		$wrapper = new MySQLDBDataWrapper($conn, null);
		$mig = new dhxMigrate($wrapper, $table_prefix.'dhx_');
		$mig->update();
	}
}


?>